﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
//Add code
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;

namespace Basic_Terminal
{
    class Serial
    {
        private System.IO.Ports.SerialPort serialPort;

        public string Serial_Name { get => serialPort.PortName;  set => serialPort.PortName = value;}

        public void Serial_Initialize(ref ComboBox cb_port)
        {
            
            this.serialPort = new System.IO.Ports.SerialPort();
            this.serialPort.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.Serial_DataRecvFunction);

            cb_port.BeginUpdate();
            foreach (string comport in SerialPort.GetPortNames())//foreach (string comport in SerialPort_TestProgram.GetPortNames())
            {
                cb_port.Items.Add(comport);
            }
            cb_port.EndUpdate();
            //SerialPort 초기 설정.
            cb_port.DataSource =  SerialPort.GetPortNames();
            serialPort.PortName = Serial_Name = cb_port.SelectedItem.ToString();
            serialPort.BaudRate = (int)115200;
            serialPort.DataBits = (int)8;
            serialPort.Parity = System.IO.Ports.Parity.None;
            serialPort.StopBits = StopBits.One;

        }
        public void Serial_DataRecvFunction(object sender, SerialDataReceivedEventArgs e)
        {

        }
        public void Serial_PortOpen(ref Button Btn_Portonoff)
        {
            try
            {
                if (serialPort.IsOpen) { //When the port is open
                    serialPort.Close();
                    Btn_Portonoff.Text = "Port Open";
                }
                else//When the port is close
                {
                    serialPort.Open();
                    Btn_Portonoff.Text = "Port Close";
                }
            }
            catch
            {
                MessageBox.Show("already port open " + Serial_Name);
               
            }
        }
    }
}
