﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
//Add code
using System.Runtime.InteropServices; //ini파일 로드 필요라이브러리
namespace Basic_Terminal
{
    public partial class Debug : Form
    {
        int LineLimit = 500;
        [DllImport("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, Int32 wMsg, bool wParam, Int32 lParam);
        private const int WM_SETREDRAW = 255;

        public Debug()
        {
            InitializeComponent();
        }



        TextBox temp_data = new TextBox();
        public void Controller_TextLoad(string text)
        {
            int nLimitLines = Convert.ToInt32(LineLimit); //제한 라인 수
            try
            {
                try
                {
                    SendMessage(this.Handle, WM_SETREDRAW, false, 0);
                }
                catch { return; }
                if (tbReceived2.Lines.Length > nLimitLines)
                {
                    LinkedList<string> tempLines = new LinkedList<string>(tbReceived2.Lines);
                    while ((tempLines.Count - nLimitLines) > 0)
                    {
                        tempLines.RemoveFirst();
                    }

                    tbReceived2.Lines = tempLines.ToArray();

                }
                try
                {
                    SendMessage(this.Handle, WM_SETREDRAW, true, 0);
                }
                catch { return; }
                tbReceived2.AppendText(text);
                tbReceived2.SelectionStart = tbReceived2.Text.Length;//맨 마지막 선택... 
                tbReceived2.ScrollToCaret();
            }
            catch { try { SendMessage(this.Handle, WM_SETREDRAW, true, 0); } catch { return; } }
        }
        public void Controller_TextLoad(byte[] text)
        {
            string AppendMessage = "\n[RX]";

            int nLimitLines = Convert.ToInt32(LineLimit); //제한 라인 수
            try
            {
                for (int i = 0; i < text.Length; i++)
                {
                    AppendMessage += Convert.ToString(text[i], 16);
                }
                //string AppendMessage = DateTime.Now.ToString("hh:mm:ss.fff") + " " + text;
                try
                {
                    tbReceived2.AppendText(AppendMessage);
                }
                catch { return; }
                try
                {
                    SendMessage(this.Handle, WM_SETREDRAW, false, 0);
                }
                catch { return; }
                if (tbReceived2.Lines.Length > nLimitLines)
                {
                    LinkedList<string> tempLines = new LinkedList<string>(tbReceived2.Lines);

                    while ((tempLines.Count - nLimitLines) > 0)
                    {
                        tempLines.RemoveFirst();
                    }

                    tbReceived2.Lines = tempLines.ToArray();
                }
                try
                {
                    SendMessage(this.Handle, WM_SETREDRAW, true, 0);
                }
                catch { return; }
                tbReceived2.Select(tbReceived2.Text.Length, 0);
                tbReceived2.ScrollToCaret();
            }
            finally { }

        }

        public void Controller_TX_TextLoad(byte[] text)
        {
            string AppendMessage = "\n[TX]";

            int nLimitLines = Convert.ToInt32(LineLimit); //제한 라인 수
            try
            {
                for (int i = 0; i < text.Length; i++)
                {
                    AppendMessage += Convert.ToString(text[i], 16);
                }
                tbReceived2.AppendText(AppendMessage);
                try
                {
                    SendMessage(this.Handle, WM_SETREDRAW, false, 0);
                }
                catch { return; }
                if (tbReceived2.Lines.Length > nLimitLines)
                {
                    LinkedList<string> tempLines = new LinkedList<string>(tbReceived2.Lines);

                    while ((tempLines.Count - nLimitLines) > 0)
                    {
                        tempLines.RemoveFirst();
                    }

                    tbReceived2.Lines = tempLines.ToArray();
                }
                try
                {
                    SendMessage(this.Handle, WM_SETREDRAW, true, 0);
                }
                catch { return; }
                tbReceived2.Select(tbReceived2.Text.Length, 0);
                tbReceived2.ScrollToCaret();
            }
            finally { }

        }
        public void Controller_DebugBoxClear()
        {
            try
            {
                this.tbReceived2.Text = "";
            }
            finally { }

        }
    
    }
}
